/*  $Id: title_screen.cpp 1392 2007-06-11 20:12:34Z grumbel $
**   __      __ __             ___        __   __ __   __
**  /  \    /  \__| ____    __| _/_______/  |_|__|  | |  |   ____
**  \   \/\/   /  |/    \  / __ |/  ___/\   __\  |  | |  | _/ __ \
**   \        /|  |   |  \/ /_/ |\___ \  |  | |  |  |_|  |_\  ___/
**    \__/\  / |__|___|  /\____ /____  > |__| |__|____/____/\___  >
**         \/          \/      \/    \/                         \/
**  Copyright (C) 2005 Ingo Ruhnke <grumbel@gmx.de>
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
** 
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
**  02111-1307, USA.
*/

#include <iostream>
#include "menu_manager.hpp"
#include "title_screen.hpp"

TitleScreen::TitleScreen()
{
  background = Sprite("images/titlescreen.sprite");
}

TitleScreen::~TitleScreen()
{
}

void
TitleScreen::on_startup()
{
  menu_manager.display_main_menu();
}

void
TitleScreen::draw()
{
  background.draw(Vector(0, 0));
}

void
TitleScreen::update(float delta, const Controller& controller)
{
  background.update(delta);
}

void
TitleScreen::handle_event(const SDL_Event& )
{
  
}

/* EOF */
